/**************************************************
 * http://homes-smart.ru/index.php/oborudovanie/bez-provodov-2-4-ggts/60-deshevyj-usb-priemnik-dlya-nrf24l01-i-nrf24le1-fz0769
Пример чтения данных с помошью USB радиомодуля FZ0769

Запуск без параметров читает данные из эфира. 
Запуск с параметрами записывает данные. Параметры должны быть в виде 4 байт:1 номер клиента.2..-4 - данные,передаваемые в эфир

compile with the command: gcc nRF-BK-USB.c rs232.c -Wall -Wextra -o2 -o nRF-BK-USB

**************************************************/
#define byted 0
#define intd 1
#define uintd 2
#define longd 3
#define ulongd 4
#define floatd 5
#define end 255

#include <stdlib.h>
#include <stdio.h>

#ifdef _WIN32
#include <Windows.h>
#else
#include <unistd.h>
#endif

#include "rs232.h"

//--
unsigned char buffer[32];
#include "nRF-USB.h"

int num=0;
unsigned char byte1 (){
 char f=buffer[num];
  num++;
  return f;
}
int byte2 (){
int f=buffer[num];
  num++;
  f=buffer[num]*256+f;
  num++;
return f;
}

long byte4 (){
 unsigned  long f=(buffer[num]+buffer[num+1]*256+(buffer[num+2]*65536L)+(buffer[num+3]*65536L*256L));
  num=num+4;
return f; 
}

float bytefloat (){
float f;
 char unsigned arr[4] = {buffer[num],buffer[num+1],buffer[num+2],buffer[num+3]};
 memcpy(&f,arr,sizeof f);
 num=num+4;
  
 return f; 
}

void readdata (int len,int chanel){ // char(1) / 2 / 2 / char(1) / 2/ 4 / float(4) 

num=0;
chanel--;
int c=0;

for (num=0;num<len;){
  
    if (dtstr[chanel][c]==byted)	printf("%d",byte1());
else if (dtstr[chanel][c]==intd)	printf("%d",byte2());
else if (dtstr[chanel][c]==uintd)	printf("%hu",(unsigned int)byte2());
else if (dtstr[chanel][c]==longd)	printf("%d",byte4());
else if (dtstr[chanel][c]==ulongd)	printf("%hu",(unsigned long)byte4());
else if (dtstr[chanel][c]==floatd)	printf("%0.1f",bytefloat());
else if (dtstr[chanel][c]==end) {
 printf("\n");
 return;
}
  printf(";"); // разделитель
c++;
}
printf("\nНет параметра end\n");
} 


//--


int main(int argc, char **argv)
{
  int n,yy,
      cport_nr=24,        /* /dev/ttyS0 (COM1 on windows) see doc.txt */
      bdrate=57600;       /* 9600 baud */

  char mode[]={'8','N','1',0} ,str[21];


  if(RS232_OpenComport(cport_nr, bdrate, mode))
  {
    printf("Can not open comport\n");

    return(0);
  }
  usleep(400000);
 // sleep(1);
  
  strcpy(str,"AT+SET=0107F0F0F0F0F0\n"); // иницилизация модуля
  RS232_SendBuf(cport_nr,(unsigned char*) str, 22);
  
  unsigned char sendd[4];

  if(argc > 4){
    sendd [0]=atoi(argv[1]);
    sendd [1]=atoi(argv[2]);
    sendd [2]=atoi(argv[3]);
    sendd [3]=atoi(argv[4]);
    
   RS232_SendBuf(cport_nr,(unsigned char*) sendd, 4);
   printf("send data\n");
  } else {
//sleep(1);
    usleep(400000);
 // while(1)
    for(yy=0; yy < 5; yy++) // 5 попыток вывести данные
  {

  n = RS232_PollComport(cport_nr, buffer,sizeof(buffer));

    if(n > 0)
    {
//for(i=0; i < 32; i++) printf("%d,",buffer[i]);printf("\n");    

readdata (32,buffer[0]);

    } else printf("no signal\n");

#ifdef _WIN32
    Sleep(100);
#else
    sleep(1);
//    usleep(100000);  /* sleep for 100 milliSeconds */
#endif
  }
  }
RS232_CloseComport(cport_nr);
  return(0);
}
//88888888888888